﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class MyGunController2 : MonoBehaviour
{
    public Vector2 turnSpeed = new Vector2 (1 , 1);
    public Vector2 degreeClamp = new Vector2 (90 , 80);
    public bool invertY;
    Quaternion _initialOrientation;
    Vector2 _currentAngles;
    CursorLockMode _previousLockState;
    bool _wasCursorVisible;

    public Rigidbody prefabShell;
    public Transform fireTransform;

    // Start is called before the first frame update
    void Start()
    {
         // Cache our starting orientation as our center point.
        _initialOrientation = transform.localRotation;

        // Cache the previous cursor state so we can restore it later.
        _previousLockState = Cursor.lockState;
        _wasCursorVisible = Cursor.visible;

        // Hide & lock the cursor for that FPS experience
        // and to avoid distractions / accidental clicks
        // from the mouse cursor moving around.
        Cursor.lockState = CursorLockMode.Locked;
        Cursor.visible = false;
    }

    // Update is called once per frame
    void Update()
    {
        Vector2 motion = new Vector2(Input.GetAxis ("Mouse X"), Input.GetAxis ("Mouse Y"));
        // Scale it by the turn speed, add it to our current angle, and clamp.
        motion = Vector2.Scale (motion , turnSpeed);
        _currentAngles += motion;
        _currentAngles = Vector2.Min (_currentAngles , degreeClamp);
        _currentAngles = Vector2.Max (_currentAngles , -degreeClamp);

        // Rotate to look in this direction, relative to our initial orientation.
        Quaternion look = Quaternion.Euler (
                            -_currentAngles.y ,                       // Yaw
                            (invertY ? -1f : 1f) * _currentAngles.x , // Pitch
                            0);                                      // Roll

        transform.localRotation = _initialOrientation * look;

        if (Input.GetButtonDown ("Fire")) {
           Fire ();
        }
    }

    void Fire ()
    {
        Rigidbody shellInstance =
               Instantiate (prefabShell , fireTransform.position , fireTransform.rotation) as Rigidbody;


        // Set the shell's velocity to the launch force in the fire position's forward direction.
         shellInstance.velocity = 20.0f * -fireTransform.forward;
     }
}
